# cnos_facts – Collect facts from remote devices running Lenovo CNOS

- Synopsis
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Collects a base set of device facts from a remote Lenovo device running on CNOS. This module prepends all of the base network fact keys with `ansible_net_<fact>`. The facts module will always collect a base set of facts from the device and can enable or disable collection of additional facts.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
auth_pass - added in 2.6 |  | Specifies the password to use if required to enter privileged mode on the remote device. If authorize is false, then this argument does nothing. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_AUTH_PASS` will be used instead.

authorize
boolean
added in 2.6

Choices:
- no ←
- yes

Instructs the module to enter privileged mode on the remote device before sending any commands. If not specified, the device will attempt to execute all commands in non-privileged mode. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_AUTHORIZE` will be used instead.

gather_subset - added in 2.6 | Default: "!config" | When supplied, this argument will restrict the facts collected to a given subset. Possible values for this argument include all, hardware, config, and interfaces. Can specify a list of values to include a larger subset. Values can also be used with an initial `!` to specify that a specific subset should not be collected.

## Notes

Note

- Tested against CNOS 10.8.1

## Examples

    Tasks: The following are examples of using the module cnos_facts.
    ---
    - name: Test cnos Facts
      cnos_facts:

    ---
    # Collect all facts from the device
    - cnos_facts:
        gather_subset: all

    # Collect only the config and default facts
    - cnos_facts:
        gather_subset:
          - config

    # Do not collect hardware facts
    - cnos_facts:
        gather_subset:
          - "!hardware"

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
ansible_net_all_ipv4_addresses list | when interfaces is configured | All IPv4 addresses configured on the device
ansible_net_all_ipv6_addresses list | when interfaces is configured | All IPv6 addresses configured on the device
ansible_net_config string | when config is configured | The current active config from the device
ansible_net_gather_subset list | always | The list of fact subsets collected from the device
ansible_net_hostname string | always | The configured hostname of the device
ansible_net_image string | always | Indicates the active image for the device
ansible_net_interfaces dictionary | when interfaces is configured | A hash of all interfaces running on the system. This gives information on description, mac address, mtu, speed, duplex and operstatus
ansible_net_memfree_mb integer | when hardware is configured | The available free memory on the remote device in MB
ansible_net_model string | always | The model name returned from the Lenovo CNOS device
ansible_net_neighbors dictionary | when interfaces is configured | The list of LLDP neighbors from the remote device
ansible_net_serialnum string | always | The serial number of the Lenovo CNOS device
ansible_net_version string | always | The CNOS operating system version running on the remote device

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Anil Kumar Muraleedharan (@amuraleedhar)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.